#pragma once

#include <vector>
#include <string>
#include <map>
#include <vector>
#include <memory>
#include <iostream>
#include "hybrid.h"

class FrontEndBase;

class FENConfigModule {
public:
  FENConfigModule(FrontEndBase& frontend);
  ~FENConfigModule();
  void configFEN();
  void configHybrid(int hybrid_index);
  bool configVMM(int hybrid_index, int vmm_index, bool enableConfigCheck=false);
  void fillGlobalRegisters(std::vector<std::string>& global, int hybrid_index, int vmm_index);
  void fillGlobalRegisters2(std::vector<std::string>& global, int hybrid_index, int vmm_index);
  void fillChRegisters(std::vector<std::string>& registers, int hybrid_index, int vmm_index);
  int readADC(int hybrid_index, int vmm_index);
  Hybrid& getHybrid(int index);
  bool enableHybrid(int hybrid, bool onOff);
  bool isHybridEnabled(int hybrid);
  void sendAll(bool useConfigCheck);

private:
  FrontEndBase *pFEN;
  Hybrid hybrids[HYBRIDS_PER_FEN];
  bool enabled_hybrids[HYBRIDS_PER_FEN] = {};
  uint32_t readWriteRegs(std::string command_reg, int index, std::string read_reg);
  uint16_t getChMap();
};
